
/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _GUESTCALLS_H_
#define _GUESTCALLS_H_


#include "vboxhdrs.h"
#include "GuestHostStructs.h"
#include "CopyFilesHandler.h" //PCOPY_FILES_BUILDING_LIST_STATUS
#include "FilesCopier.h"
#include <string>
#include <vector>
using namespace std;

typedef enum _VERCHK_STATUS
{
    VERCHK_SUCCESS = 1,
    VERCHK_GEN_FAILURE,
    VERCHK_VER_MISMATCH_CURRENT_IS_OLDER,
    VERCHK_VER_MISMATCH_CURRENT_IS_NEWER,
    VERCHK_TOOLS_ARE_NOT_INSTALLED,
    VERCHK_HOSTHOOK_IS_NOT_INSTALLED
    
}VERCHK_STATUS;

UINT
VMInit();

UINT
GuestCall_GetDroppedFileList(
    IN  UINT ClientId OPTIONAL,
	IN  UINT DropHandle,
	OUT vector<wstring> *pFilesList
	);


VERCHK_STATUS
GuestCall_CheckHostHookVersion(
    PUINT pHostHookVersion,
    PUINT pNativeVboxErrorCode
    );

UINT
GuestCall_CFH_Begin(
    IN uint32_t ClientId,
    IN uint32_t DropHandle,
    OUT uint32_t *pHandle
    );

UINT
GuestCall_CFH_GetBuildingListStatus(
    IN  UINT ClientId,
	IN  UINT Handle,
	OUT PCOPY_FILES_BUILDING_LIST_STATUS pCopyFilesBuildingListStatus
	);

UINT
GuestCall_CFH_GetCurrentFileName(
    IN  UINT ClientId,
	IN  UINT Handle,
	OUT PCOPY_FILES_GET_CURRENT_FILENAME pCopyFilesGetCurrentFileName
	);

UINT
GuestCall_CFH_GetCurrentStream(
    IN  UINT ClientId,
	IN  UINT Handle,
	IN OUT PVOID pBuffer,
	IN  UINT BufferSize,
	OUT PUINT pBytesCopied,
	OUT PUINT64 pStreamOffset
	);

UINT
GuestCall_CFH_MoveToNextItem(
    IN  UINT ClientId,
	IN  UINT Handle,
	UINT64 ItemId
	);

UINT
GuestCall_CFH_End(
	IN  UINT ClientId,
	IN  UINT Handle
	);

UINT
GuestCall_HSM_NotifyGuestClipboardHasFiles(
    IN  UINT ClientId,
    IN  UINT OSVersion,
    IN  UINT Is64bit
    );

UINT
GuestCall_HSM_WaitForInputForGuestServer(
    IN  UINT ClientId,
    IN  OUT PVOID pBuffer,
    IN  UINT BufferSize,
    OUT UINT *pOutputSize,
    OUT UINT *pPacketId
    );

UINT
GuestCall_HSM_SendOutputFromGuestServer(
    IN  UINT ClientId,
    IN OUT UINT *pErrorCode,
    IN  PVOID pBuffer,
    IN  UINT BufferSize,
    IN  UINT PacketId
    );


class CGuestFromHostCopierHelper : public CFileCopierHelper
{

public:

    virtual
    UINT
    CFH_Begin(
        IN uint32_t ClientId,
        IN uint32_t DropHandle,
        OUT uint32_t *pHandle
        ){ return GuestCall_CFH_Begin( ClientId, DropHandle, pHandle );  }

    virtual
    UINT
    CFH_GetBuildingListStatus(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	OUT PCOPY_FILES_BUILDING_LIST_STATUS pCopyFilesBuildingListStatus
    	){  return GuestCall_CFH_GetBuildingListStatus(ClientId,Handle,pCopyFilesBuildingListStatus); }

    virtual
    UINT
    CFH_GetCurrentFileName(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	OUT PCOPY_FILES_GET_CURRENT_FILENAME pCopyFilesGetCurrentFileName
    	){ return GuestCall_CFH_GetCurrentFileName(ClientId,Handle,pCopyFilesGetCurrentFileName); }

    virtual
    UINT
    CFH_GetCurrentStream(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	IN OUT PVOID pBuffer,
    	IN  UINT BufferSize,
    	OUT PUINT pBytesCopied,
    	OUT PUINT64 pStreamOffset
    	){return GuestCall_CFH_GetCurrentStream(ClientId,Handle,pBuffer,BufferSize,pBytesCopied,pStreamOffset); }
    

    virtual
    UINT
    CFH_MoveToNextItem(
        IN  UINT ClientId,
    	IN  UINT Handle,
    	UINT64 ItemId
    	)
    { return GuestCall_CFH_MoveToNextItem(ClientId,Handle,ItemId); }

    virtual
    UINT
    CFH_End(
    	IN  UINT ClientId,
    	IN  UINT Handle
    	){ return GuestCall_CFH_End( ClientId, Handle ); }
    

}; //CGuestFromHostCopierHelper

VOID
Dbg_GuestCall_DumpInfo();

#endif //_GUESTCALLS_H_
