/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <windows.h>
#include "DllMain.h"
#include "ExplorerClassFactory.h"
#include "guid.h"
#include "DbgPrintf.h"
#include <memory.h>
//#include <iprt/cdefs.h>

HINSTANCE g_DllHinst = NULL;
ULONG g_DllRefs = 0;


/*void* operator new(size_t Bytes)
{
    return malloc( Bytes);
}

void operator delete(void* ptr)
{
    if ( ptr )
        free( ptr );
}*/

HINSTANCE
CALLBACK
GetModuleInstance()
{
	return g_DllHinst;
}


EXTERN_C
BOOL
WINAPI
DllMain(
    HINSTANCE aHandle,
    DWORD  aReason,
    LPVOID aReserved
    )
{
    static BOOL s_bComWasInit = FALSE;

    if ( DLL_PROCESS_ATTACH == aReason )
    {
        g_DllHinst = aHandle;

        DbgPrintf( "HostOS: ContextMenuHandler 64bit: attaching to process %u,handle=%p ustr=[%ws]\n", GetCurrentProcessId(), aHandle, L"TEST_UNI" );

        //init com is required for converting .lnk files

        if ( !SUCCEEDED( CoInitialize( NULL ) ) )
        {
            DbgPrintf( "Cannot init COM\n", GetCurrentProcessId() );
            return FALSE;
        }
        else
        {
            s_bComWasInit = TRUE;
        }

    }
    else if ( DLL_PROCESS_DETACH == aReason )
    {
        DbgPrintf( "HostOS ContextMenu 64bit:: detaching from process %u\n", GetCurrentProcessId() );

        if ( s_bComWasInit )
        {
            s_bComWasInit = FALSE;
            CoUninitialize();
        }
    }

    return TRUE;
}


STDAPI
DllCanUnloadNow()
{
    //DbgPrintf( "DllCanUnloadNow called\n" );

    if ( g_DllRefs == 0 )
        return S_OK;
    else
        return S_FALSE;
}


STDAPI
DllGetClassObject(
    REFCLSID rclsid,
    REFIID riid,
    LPVOID *ppv
    )
{
    HRESULT retcode = CLASS_E_CLASSNOTAVAILABLE;

    //DbgPrintf( "DllGetClassObject called\n" );

    if ( IsEqualIID( rclsid, CLSID_HOSTCONTEXTMENU ) )
    {
        CExplorerClassFactory *pExplorerClassFactory = new CExplorerClassFactory;

        if ( pExplorerClassFactory )
        {
            retcode = pExplorerClassFactory->QueryInterface(
                riid,
                ppv
                );

            if ( retcode == NOERROR )
            {
                return retcode;
            }

            delete pExplorerClassFactory;
        }
        else
        {
            retcode = E_OUTOFMEMORY;
        }
    }

    //error
    *ppv = NULL;
    return retcode;
}
