/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _CHK_MALLOC_H_
#define _CHK_MALLOC_H_

#ifdef _DEBUG
#define USE_CHECKED_MALLOC_FREE
#endif    

#ifdef _MSC_VER

//too many actual parameters for macro ''
#pragma warning(error: 4002)

#endif 
    
#ifdef USE_CHECKED_MALLOC_FREE

#ifdef __cplusplus

#define EXTernC extern "C"

void * __cdecl operator new( size_t num_bytes );
void * __cdecl operator new[]( size_t num_bytes );

void __cdecl operator delete( void *ptr );
void __cdecl operator delete[]( void *ptr );


#else

#define EXTernC extern

#endif

   
EXTernC
void *
chk_malloc( size_t Bytes );

EXTernC
void
chk_free( void * pPtr );


#define MALLOC( _BYTES ) chk_malloc( _BYTES )
#define FREE( _PTR ) chk_free( _PTR )

#else // USE_CHECKED_MALLOC_FREE is not defined

#include <memory.h>

#define MALLOC( _BYTES ) malloc( (_BYTES) )
#define FREE( _PTR ) free( _PTR )

         
#endif //USE_CHECKED_MALLOC_FREE
    
    
#endif //_CHK_MALLOC_H_