/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _FILE_OPERATIONS_PROGRESS_DLG_H_
#define _FILE_OPERATIONS_PROGRESS_DLG_H_

#include <windows.h>
#include <ShlObj.h>
#include "shlobj_ex.h"


//CoInitilize should be called before using these classes

class COM_CPrepareFileCopyingDlg
{

public:

    COM_CPrepareFileCopyingDlg();
    ~COM_CPrepareFileCopyingDlg();

public:

    VOID
    ShowProgress(
		HWND hWndParent,
        ULONG FileCount,
        ULONG FolderCount,
		ULONG64 DiscoveredItemsSize,
		LPCWSTR lpszDestFolder
        );

	VOID
	EndDialog();

    BOOL
    IsCancelled();

private:

    IProgressDialog * m_ProgressDlg;
	BOOL		      m_InitFailed;
	HINSTANCE		  m_Shell32Dll;

};


class COM_CFileCopyingProgressDlg
{

public:

	COM_CFileCopyingProgressDlg();
	~COM_CFileCopyingProgressDlg();

public:

    VOID
    ShowProgress(
		HWND hWndParent,
		ULONG   AllFilesAndFoldersCount,
		ULONG64 ProcessedItemsSize,
		ULONG64 AllItemsSize,
		LPCWSTR lpszDestFile
        );

	VOID
	EndDialog();

    BOOL
    IsCancelled();


private:

    IProgressDialog * m_ProgressDlg;
	BOOL		      m_InitFailed;
	HINSTANCE		  m_Shell32Dll;


}; //COM_CFileCopyingProgressDlg


#endif //_FILE_OPERATIONS_PROGRESS_DLG_H_

