/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "LangTools.h"
#include <windows.h>
#include "SecureFuncs.h"
#include "ChkMAlloc.h"
#include <strsafe.h>

extern
HINSTANCE 
CALLBACK 
GetModuleInstance();


wstring
LangGetStringW( ULONG StringId )
{
	WCHAR wszBuff[512] = L"";

	SetLastError( ERROR_SUCCESS );

	int ret = LoadStringW(
		GetModuleInstance(),
		StringId,
		wszBuff,
		ARRAYSIZE(wszBuff)
		);


	if ( ret == 0 /*&&  dwGle != ERROR_SUCCESS*/ )
	{
		StringCchPrintfW(
			wszBuff,
			ARRAYSIZE(wszBuff),
			L"Unknown string id : %u",
			StringId
			);

		return wszBuff;

	}

	return wszBuff;

}

string
LangGetStringA( ULONG StringId )
{
	CHAR szBuff[512] = "";

	SetLastError( ERROR_SUCCESS );

	int ret = LoadStringA(
		GetModuleInstance(),
		StringId,
		szBuff,
		ARRAYSIZE(szBuff)
		);


	if ( ret == 0 /*&& dwGle != ERROR_SUCCESS*/ )
	{
		StringCchPrintfA(
			szBuff,
			ARRAYSIZE(szBuff),
			"Unknown string id : %u",
			StringId
			);

		return szBuff;

	}

	return szBuff;

}

VOID
LangSetDlgItemTextW( 
	HWND hDlg, 
	ULONG ItemId, 
	ULONG StringId 
	)
{
	SetDlgItemTextW(
		hDlg,
		ItemId,
		LangGetStringW( StringId ).c_str()
		);
}

VOID
LangErrorMessageBox(
    ULONG LangIdText
    )
{
    MessageBoxW(
        NULL,
        LangGetStringW( LangIdText ).c_str(),
        LangGetStringW( IDS_ERROR ).c_str(),
        MB_SETFOREGROUND | MB_ICONWARNING | MB_APPLMODAL
        );
}

VOID
LangErrorMessageBoxFmt(
    ULONG LangIdFmt,
    ...
    )
{

    va_list vaList;
    WCHAR szBuf[512] = L"";

    va_start( vaList, LangIdFmt );

    StringCchVPrintfW( szBuf, ARRAYSIZE(szBuf),  LangGetStringW( LangIdFmt ).c_str(), vaList );
    szBuf[ARRAYSIZE(szBuf) - 1 ] = 0;

    MessageBoxW(
        NULL,
        szBuf,
        LangGetStringW( IDS_ERROR ).c_str(),
        MB_SETFOREGROUND | MB_ICONWARNING | MB_APPLMODAL
        );
}


wstring
LangFormatW(
    ULONG LangIdFmt,
    ...
    )
{
    va_list vaList;
    WCHAR szBuf[512] = L"";

    va_start( vaList, LangIdFmt );

    StringCchVPrintfW( szBuf, ARRAYSIZE(szBuf), LangGetStringW( LangIdFmt ).c_str(), vaList );
    szBuf[ARRAYSIZE(szBuf) - 1 ] = 0;
        
    return szBuf;
     
}

string
LangFormatA(
    ULONG LangIdFmt,
    ...
    )
{
    va_list vaList;
    CHAR szBuf[512] = "";

    va_start( vaList, LangIdFmt );

    StringCchVPrintfA( szBuf, ARRAYSIZE(szBuf), LangGetStringA( LangIdFmt ).c_str(), vaList );
    szBuf[ARRAYSIZE(szBuf) - 1 ] = 0;
        
    return szBuf;
     
}

